// mainfrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "tip_test.h"

#include "mainfrm.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(IDM_DECREASE_CLEARANCE, OnDecreaseClearance)
	ON_COMMAND(IDM_ENABLE_FLYBY, OnEnableFlyby)
	ON_COMMAND(IDM_ENABLE_TOOLTIPS, OnEnableTooltips)
	ON_COMMAND(IDM_INCREASE_CLEARANCE, OnIncreaseClearance)
	ON_COMMAND(IDM_SET_FONT, OnSetFont)
	ON_UPDATE_COMMAND_UI(IDM_ENABLE_FLYBY, OnUpdateEnableFlyby)
	ON_UPDATE_COMMAND_UI(IDM_ENABLE_TOOLTIPS, OnUpdateEnableTooltips)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// arrays of IDs used to initialize control bars

// toolbar buttons - IDs are command buttons
static UINT BASED_CODE buttons[] =
{
	// same order as in the bitmap 'toolbar.bmp'
	ID_FILE_NEW,
	ID_FILE_OPEN,
	ID_FILE_SAVE,
		ID_SEPARATOR,
	ID_EDIT_CUT,
	ID_EDIT_COPY,
	ID_EDIT_PASTE,
		ID_SEPARATOR,
	ID_FILE_PRINT,
	ID_APP_ABOUT,
};

static UINT BASED_CODE indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;

	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadBitmap(IDR_MAINFRAME) ||
		!m_wndToolBar.SetButtons(buttons,
		  sizeof(buttons)/sizeof(UINT)))
	{
		TRACE("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE("Failed to create status bar\n");
		return -1;      // fail to create
	}

	return 0;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

// WARNING: NONE OF THE FOLLOWING CODE CHECKS TO MAKE SURE m_wndToolBar IS VALID
// DON'T USE THIS AS IS!

void CMainFrame::OnUpdateEnableFlyby(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(m_wndToolBar.GetEnableFlyBy());
}

void CMainFrame::OnUpdateEnableTooltips(CCmdUI* pCmdUI)
{
	pCmdUI->SetCheck(m_wndToolBar.GetEnableToolTips());
}

void CMainFrame::OnIncreaseClearance()
{
	m_wndToolBar.SetClearance(m_wndToolBar.GetClearance() + 1);	
}

void CMainFrame::OnDecreaseClearance()
{
	m_wndToolBar.SetClearance(m_wndToolBar.GetClearance() - 1);	
}

void CMainFrame::OnEnableFlyby()
{
	m_wndToolBar.EnableFlyBy(!m_wndToolBar.GetEnableFlyBy());
}

void CMainFrame::OnEnableTooltips()
{
	m_wndToolBar.EnableToolTips(!m_wndToolBar.GetEnableToolTips());
}

void CMainFrame::OnSetFont()
{
	CFontDialog* dlg = new CFontDialog();
	if ( dlg->DoModal() == IDOK )
		m_wndToolBar.SetFont((LOGFONT*)dlg->m_cf.lpLogFont);
		
	delete dlg;
}
